/**
*
*   Asynchronous.js
*   @version: 0.4.5
*
*   Simple JavaScript class to manage asynchronous, parallel, linear, sequential and interleaved tasks
*   https://github.com/foo123/asynchronous.js
*
**/!function(n,e,t){"use strict";var r,o="object"==typeof module&&module.exports,s="function"==typeof define&&define.amd;o?module.exports=(module.$deps=module.$deps||{})[e]=module.$deps[e]||t.call(n,{NODE:module})||1:s&&"function"==typeof require&&"function"==typeof require.specified&&require.specified(e)?define(e,["require","exports","module"],function(e,r,o){return t.call(n,{AMD:o})}):e in n||(n[e]=r=t.call(n,{})||1)&&s&&define(e,[],function(){return r})}(this,"Asynchronous",function(exports){return!function(root,exports,undef){"use strict";function formatOptions(n){var e,t=[];if(n)for(e in n)t.push(e+"="+n[e]);return t.join(",")}function runParallelised(n){n.$runmode=PARALLELISED,n.$running=!1}function runLinearised(n,e){var t,r=n,o=r.$queue;if(r.$runmode=LINEARISED,o){for(;o.length&&(!o[0]||!o[0].canRun());)o.shift();o.length?(r.$running=!0,t=o.shift(),e?t.runWithArgs(e):t.run(),t.complete()):r.$running=!1}}function runInterleaved(n,e){var t,r=n,o=r.$queue,s=0;if(r.$runmode=INTERLEAVED,o&&o.length){for(r.$running=!0;s<o.length;)t=o[s],t&&t.canRun()?(e?t.runWithArgs(e):t.run(),t.isFinished()?(o.shift(),t.complete()):s++):o.shift();r.$running=!1,r.$timer=SetTime(curry(runInterleaved,r),r.$interval)}}function runSequenced(n,e){var t,r=n,o=r.$queue;r.$runmode=SEQUENCED,o&&o.length&&(t=o[0],t&&t.canRun()?(r.$running=!0,e?t.runWithArgs(e):t.run(),t.isFinished()&&(o.shift(),t.complete())):o.shift(),r.$running=!1,r.$timer=SetTime(curry(runSequenced,r),r.$interval))}var PROTO="prototype",HAS="hasOwnProperty",Obj=Object,Arr=Array,Func=Function,FP=Func[PROTO],OP=Obj[PROTO],AP=Arr[PROTO],slice=FP.call.bind(AP.slice),toString=OP.toString,is_function=function(n){return"function"==typeof n},is_instance=function(n,e){return n instanceof e},SetTime=setTimeout,ClearTime=clearTimeout,UNDEFINED=undef,UNKNOWN=0,NODE=1,BROWSER=2,DEFAULT_INTERVAL=60,NONE=0,INTERLEAVED=1,LINEARISED=2,PARALLELISED=3,SEQUENCED=4,isNode="undefined"!=typeof global&&"[object global]"===toString.call(global),isNodeProcess=!(!isNode||!process.env.NODE_UNIQUE_ID),isBrowser=!isNode&&"undefined"!=typeof navigator,isWebWorker=isBrowser&&"function"==typeof importScripts&&is_instance(navigator,WorkerNavigator),isBrowserWindow=isBrowser&&!isWebWorker&&!!root.opener,isAMD="function"==typeof define&&define.amd,supportsMultiThread=isNode||"function"==typeof Worker,isThread=isNodeProcess||isWebWorker,Thread,numProcessors=isNode?require("os").cpus().length:4,fromJSON=JSON.parse,toJSON=JSON.stringify,onMessage,curry=function(n,e){return function(){return n(e)}},URL="undefined"!=typeof root.webkitURL?root.webkitURL:"undefined"!=typeof root.URL?root.URL:null,blobURL=function(n,e){return n&&URL?URL.createObjectURL(new Blob(n.push?n:[n],e||{type:"text/javascript"})):n},path=function(n){var e;return isNode?{file:__filename,path:__dirname}:isWebWorker?{file:e=self.location.href,path:e.split("/").slice(0,-1).join("/")}:isAMD&&n&&n.uri?{file:e=n.uri,path:e.split("/").slice(0,-1).join("/")}:isBrowser&&(e=document.getElementsByTagName("script"))&&e.length?{file:e=e[e.length-1].src,path:e.split("/").slice(0,-1).join("/")}:{path:null,file:null}},thisPath=path(exports.AMD),tpf=thisPath.file,notThisPath=function(n){return!(!n||!n.length||n===tpf)},extend=function(n,e){if(n=n||{},e)for(var t in e)e[HAS](t)&&(n[t]=e[t]);return n},_uuid=0;if(onMessage=isWebWorker?function(n){n&&(onmessage=n)}:isNodeProcess?function(n){n&&process.on("message",function(e){n(fromJSON(e))})}:function(){},isNode){var fs=require("fs"),ps=require("child_process");root.close=function(){process.exit()},root.postMessage=function(n){process.send(toJSON({data:n}))},root.importScripts=function(scripts){if(scripts&&(scripts=scripts.split(",")).length)for(var i=0,src,ok;i<scripts.length;){ok=!0;try{src=fs.readFileSync(scripts[i++]),eval(src)}catch(e){ok=e}if(!0!==ok)throw ok}},Thread=function(n){var e=this;e.process=ps.fork(n),e.process.on("message",function(n){e.onmessage&&e.onmessage(fromJSON(n))}),e.process.on("error",function(n){e.onerror&&e.onerror(n)})},Thread[PROTO]={constructor:Thread,process:null,onmessage:null,onerror:null,postMessage:function(n){return this.process&&this.process.send(toJSON({data:n})),this},terminate:function(){return this.process&&(this.process.kill(),this.process=null),this}}}else Thread=root.Worker;var BrowserWindow=function(n){var e=this;return e instanceof BrowserWindow?(e.$id=(++_uuid).toString(16),void(e.options=extend({width:400,height:400,toolbar:"no",location:"no",directories:"no",status:"no",menubar:"no",scrollbars:"yes",resizable:"yes"},n))):new BrowserWindow(n)};BrowserWindow[PROTO]={constructor:BrowserWindow,options:null,$id:null,$window:null,dispose:function(){var n=this;return n.$window&&n.close(),n.$window=null,n.$id=null,n.options=null,n},close:function(){var n=this;return n.$window&&(n.$window.closed||n.$window.close(),n.$window=null),n},ready:function(n,e){var t=this,r=function o(){!t.$window||n&&!t.$window[n]?setTimeout(o,40):e()};return setTimeout(r,0),t},open:function(n){var e=this;return!e.$window&&n&&(e.$window=window.open(n.push?blobURL(["﻿"].concat(n),{type:"text/html;charset=utf-8"}):n,e.$id,formatOptions(e.options))),e},write:function(n){var e=this;return e.$window&&n&&e.$window.document.write(n),e}};var Task=function(n){if(n instanceof Task)return n;if(!(this instanceof Task))return new Task(n);var e,t=this,r=null,o=null,s=null,i=!1,u=!1,a=!1,l=!1,c=!1,f=!1,p=null,d=0,h=1,m=null,$=null,v=null,g=undef;t.queue=function(n){return arguments.length?(r=n,t):r},t.jumpNext=function(n){r&&r.jumpNext(!1,n)},t.abort=function(n){r&&(r.abort(!1),n&&(r.dispose(),r=null))},t.dispose=function(){r&&(r.dispose(),r=null)},t.task=function(n){return o=n,t},n&&t.task(n),t.run=e=function(){return o.jumpNext=t.jumpNext,o.abort=t.abort,o.dispose=t.dispose,g=o(),i=!0,o.jumpNext=null,o.abort=null,o.dispose=null,g},t.runWithArgs=function(n){return o.jumpNext=t.jumpNext,o.abort=t.abort,o.dispose=t.dispose,g=o.apply(null,n),i=!0,o.jumpNext=null,o.abort=null,o.dispose=null,g},t.canRun=function(){return o&&(!i||u||a||l||c||f)?(u||a)&&d>=m?!1:a&&!p?!1:(l||c)&&g===$?!1:!0:!1},t.iif=function(n,e,r){return n?t.task(e):arguments.length>2&&t.task(r),t},t.until=function(n){return g=undef,p=null,$=n,c=!0,f=!1,u=!1,a=!1,l=!1,t.run=e,t},t.untilNot=function(n){return g=undef,p=null,v=n,f=!0,c=!1,u=!1,a=!1,l=!1,t.run=e,t},t.loop=function(n,e,r){return g=undef,p=null,d=e||0,h=r||1,m=n,u=!0,c=!1,f=!1,a=!1,l=!1,t.run=function(){var n;return n=o(d),d+=h,g=n,i=!0,n},t},t.each=function(n){return g=undef,p=n,d=0,h=1,m=n?n.length||0:0,a=!0,c=!1,f=!1,u=!1,l=!1,t.run=function(){var n;return n=o(p[d],d),d++,g=n,i=!0,n},t},t.recurse=function(n,e){return p=null,g=n,$=e,l=!0,c=!1,f=!1,u=!1,a=!1,t.run=function(){var n;return n=o(g),g=n,i=!0,n},t},t.isFinished=function(){var n=!i||f||c||u||a||l;return n&&(c||l)&&g===$&&(n=!1),n&&f&&g!==v&&(n=!1),n&&(u||a)&&d>=m&&(n=!1),!n},t.onComplete=function(n){return s=n||null,t},t.complete=function(){return s&&is_function(s)&&s(),t}},Asynchronous=exports.Asynchronous=function(n,e){if(is_instance(n,Task))return n;if(is_function(n))return new Task(n);if(!is_instance(this,Asynchronous))return new Asynchronous(n);var t=this;t.$interval=arguments.length?parseInt(n,10):DEFAULT_INTERVAL,t.$timer=null,t.$runmode=NONE,t.$running=!1,t.$queue=[],isThread&&!1!==e&&t.initThread()};if(Asynchronous.VERSION="0.4.5",Asynchronous.Thread=Thread,Asynchronous.Task=Task,Asynchronous.BrowserWindow=BrowserWindow,Asynchronous.MODE={NONE:NONE,INTERLEAVE:INTERLEAVED,LINEAR:LINEARISED,PARALLEL:PARALLELISED,SEQUENCE:SEQUENCED},Asynchronous.Platform={UNDEFINED:UNDEFINED,UNKNOWN:UNKNOWN,NODE:NODE,BROWSER:BROWSER},Asynchronous.supportsMultiThreading=function(){return supportsMultiThread},Asynchronous.isPlatform=function(n){return NODE===n?isNode:BROWSER===n?isBrowser:undef},Asynchronous.isThread=function(n){return NODE===n?isNodeProcess:BROWSER===n?isWebWorker:isThread},Asynchronous.path=path,Asynchronous.blob=blobURL,Asynchronous.load=function(n,e,t){if(n){var r=function(){n=n.split(".");for(var e=root;n.length;)n[0]&&n[0].length&&e[n[0]]&&(e=e[n[0]]),n.shift();return e&&root!==e?is_function(e)?!1!==t?new e:e():e:void 0};return e&&e.length&&(e=e.filter(notThisPath),e.length&&importScripts(e.join(","))),r()}return null},Asynchronous.serialize=function(n){n=n||new Asynchronous;var e=function(e){var t=function(){var t=this,r=arguments;n.step(function(){e.apply(t,r)}),n.$running||n.run(LINEARISED)};return t.free=function(){return e},t};return e.free=function(){n&&n.dispose(),n=null},e},Asynchronous[PROTO]={constructor:Asynchronous,$interval:DEFAULT_INTERVAL,$timer:null,$queue:null,$thread:null,$events:null,$runmode:NONE,$running:!1,dispose:function(){var n=this;return n.unfork(!0),n.$timer&&ClearTime(n.$timer),n.$thread=null,n.$timer=null,n.$interval=null,n.$queue=null,n.$runmode=NONE,n.$running=!1,n},empty:function(){var n=this;return n.$timer&&ClearTime(n.$timer),n.$timer=null,n.$queue=[],n.$runmode=NONE,n.$running=!1,n},interval:function(n){return arguments.length?(this.$interval=parseInt(n,10),this):this.$interval},fork:function(n,e,t){var r,o,s,i=this;if(!i.$thread){if(!supportsMultiThread)throw i.$thread=null,new Error("Asynchronous: Multi-Threading is NOT supported!");isNode?(o="Asynchronous: Thread (Process): ",s="Asynchronous: Thread (Process) Error: "):(o="Asynchronous: Thread (Worker): ",s="Asynchronous: Thread (Worker) Error: "),i.$events=i.$events||{},r=i.$thread=new Thread(tpf),r.onmessage=function(n){if(n.data.event){var e=n.data.event,t=n.data.data||null;i.$events&&i.$events[e]?i.$events[e](t):("console.log"===e||"console.error"===e)&&console.log(o+(t.output||""))}},r.onerror=function(n){if(!i.$events||!i.$events.error)throw new Error(s+n.message+" file: "+n.filename+" line: "+n.lineno);i.$events.error(n)},i.send("initThread",{component:n||null,asInstance:!1!==t,imports:e?[].concat(e):null})}return i},unfork:function(n){var e=this;return e.$thread&&(e.send("dispose"),!0===n&&e.$thread.terminate()),e.$thread=null,e.$events=null,e},initThread:function(){var n=this;return isThread&&(n.$events={},onMessage(function(e){var t=e.data.event,r=e.data.data||null;t&&n.$events[t]?n.$events[t](r):"dispose"===t&&(n.dispose(),close())})),n},listen:function(n,e){return n&&is_function(e)&&this.$events&&(this.$events[n]=e),this},unlisten:function(n,e){return n&&this.$events&&this.$events[n]&&(2>arguments.length||e===this.$events[n])&&delete this.$events[n],this},send:function(n,e){return n&&(isThread?postMessage({event:n,data:e||null}):this.$thread&&this.$thread.postMessage({event:n,data:e||null})),this},task:function(n){return is_instance(n,Task)?n:is_function(n)?Task(n):void 0},iif:function(){var n=arguments,e=new Task;return e.iif.apply(e,n)},until:function(){var n=slice(arguments),e=new Task(n.pop());return e.until.apply(e,n)},untilNot:function(){var n=slice(arguments),e=new Task(n.pop());return e.untilNot.apply(e,n)},loop:function(){var n=slice(arguments),e=new Task(n.pop());return e.loop.apply(e,n)},each:function(){var n=slice(arguments),e=new Task(n.pop());return e.each.apply(e,n)},recurse:function(){var n=slice(arguments),e=new Task(n.pop());return e.recurse.apply(e,n)},step:function(n){var e=this;return n&&e.$queue.push(e.task(n).queue(e)),e},steps:function(){var n,e,t=this,r=arguments;for(e=r.length,n=0;e>n;n++)t.step(r[n]);return t},jumpNext:function(n,e){var t=this,r=t.$queue;return e=e||0,!1!==n?function(){return e<r.length&&(e>0&&r.splice(0,e),t.run(t.$runmode)),t}:(e<r.length&&(e>0&&r.splice(0,e),t.run(t.$runmode)),t)},jumpNextWithArgs:function(n,e,t){var r=this,o=r.$queue;return e=e||0,!1!==n?function(){return e<o.length&&(e>0&&o.splice(0,e),r.run(r.$runmode,arguments)),r}:(e<o.length&&(e>0&&o.splice(0,e),r.run(r.$runmode,t)),r)},abort:function(n,e){var t=this;return!1!==n?function(){return e&&e>0?SetTime(function(){t.empty()},e):t.empty(),t}:(e&&e>0?SetTime(function(){t.empty()},e):t.empty(),t)},run:function(n,e){var t=this;return arguments.length?t.$runmode=n:n=t.$runmode,e=e||null,SEQUENCED===n?runSequenced(t,e):INTERLEAVED===n?runInterleaved(t,e):LINEARISED===n?runLinearised(t,e):PARALLELISED===n&&runParallelised(t,e),t}},isThread){var Component=null;root.console={log:function(n){postMessage({event:"console.log",data:{output:n||""}})},error:function(n){postMessage({event:"console.error",data:{output:n||""}})}},onMessage(function(n){var e=n.data.event,t=n.data.data||null;switch(e){case"initThread":t&&t.component&&(Component&&(is_function(Component.dispose)&&Component.dispose(),Component=null),Component=Asynchronous.load(t.component,t.imports,t.asInstance));break;case"dispose":default:Component&&(is_function(Component.dispose)&&Component.dispose(),Component=null),close()}})}}(this,exports),exports.Asynchronous});